Subject: [Dime] WGLC Review of draft-ietf-dime-app-design-guide-15

From: Ben Campbell <[email-masked]>
Date: Tue, 28 Aug 2012 16:54:53 -0500

Hi,

The draft gives good guidance overall. I do have a few comments, though:

Substantive Comments:

-- section 4:

The section seems to talk mainly about syntax, rather than semantics. Is there any guidance to give about things (applications, commands, avps) that might be syntactically similar but mean very different things?

-- 4.3.2, last paragraph:

Does it become an error if a peer uses the "no-longer-used-but-not-deleted" avp?

-- 5.9

Does the advice in this section open up an unmanaged extension vector? In the extreme case, would this encourage an external group to register a single application id for a highly extensible application, then bypass IETF extension processes by just adding more functions to the original application?

-- 8:

The security considerations say that this draft does not define nor address security related protocols or schemes. But there was an entire section dedicated to the use of IPSec, which certainly seems to address a security related protocol and scheme. 

Editorial Comments:

-- section 1:

I'm confused by list item 2. It seems to talk both about adding new function to an existing application and creating a new application. I suspect this is about the case of using two applications together to effectively add function--if so, that could be more clear.

-- section 3, Major Extension case: "... in such a way that this implies backward compatible change to the existing application ..."

Do you mean a _non_ backwards compatible change?

-- section 4.1, third bullet: " Care should be taken to avoid a liberal method of importing existing command’s CCF syntax specification."

I'm not sure I understand what you mean by a "liberal method of importing"?

"This would result in a monolithic and hard to manage applications..." 

singular/plural disagreement

-- 4.2, 2nd paragraph

s/" indicates of a flawed design"/"indicates a flawed design"

-- 4.3, 2nd paragraph:

s/"It is worth to note that"/"It is worth noting that"   [Or even better, skip the whole clause]

s/"in the [RFC3588]"/"in [RFC3588]"

-- 4.3.1, title:

s/ommand/command

-- 4.3.1, 2nd bullet list, 3rd bullet:

The second half of this bullet item seems redundant with the previous bullet.

-- 5.8

The section may have some meaning obscured by passive voice. In particular, who foresaw that translation would be easy, who acknowledged that it wasn't, and who might foresee the need for RADIUS interworking? (I think those are the work group, the work group, and application designers, respectively)

-- 5.9, third bullet: "Applications that do not understand these AVP can discard it ..."

singular/plural disagreement

-- 5.11, 1st paragraph: "However, IPsec Additional security mechanisms such as IPsec can also be deployed to secure connections between Diameter peers."

Do you mean "IPSec can also be deployed...", or "Additional security mechanisms such as IPSec can also be deployed..."?

Thanks!

Ben.